
/******************************************************************************
* MODULE     : conv_cross.cc
* DESCRIPTION: Build Cross object during conversion
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>

generic
evaluator_rep::evaluate_conv_cross (generic g) {
  list l= cdr (as_list (g)), r;
  while (!nil (l)) {
    generic res= evaluate (car (l));
    if (gentype (res) == MM_EXCEPTION_TYPE) return res;
    r= cons (res, r);
    l= cdr (l);
  }
  return cons (MM_TUPLE, reverse (r));
}
