
/******************************************************************************
* MODULE     : keyw_case.cc
* DESCRIPTION: cases
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <mm_int.hh>

generic
evaluator_rep::evaluate_case (generic g) {
  generic expr = evaluate (g[1]);
  if (gentype (expr) != VALUE_TYPE) return expr;
  list cases= as_list (g[2]);
  while (!nil (cases)) {
    generic tag= car (cases);
    if (is_func (tag, MM_ELSE, 1)) return evaluate (tag[1]);
    list matches= as_list (tag[0]);
    while (!nil (matches)) {
      generic test= list (MM_EQUAL, expr, car (matches));
      generic res = evaluate_as (test, MM_BOOL);
      if (gentype (res) != VALUE_TYPE) return res;
      if (as_mm_int (as_value (res) -> val) -> i)
	return evaluate (tag[1]);
      matches= cdr (matches);
    }
    cases= cdr (cases);
  }
  return VAL_VOID;
}
