
/******************************************************************************
* MODULE     : keyw_define.cc
* DESCRIPTION: Definition of interactive constants
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>

generic
evaluator_rep::evaluate_define (generic g) {
  if (is_func (g[1], MM_TYPE, 2)) {
    generic rew= as_declaration (g);
    if (is_mm_exception (rew)) return rew;
    value val= as_value (rew[1]);
    if (!is_symbol (rew[0]))
      return mm_exception (rew[0], "Not a symbol");
    return declare (as_symbol (rew[0]), val);
  }
  else return mm_exception (g, "Bad definition");
}
