
/******************************************************************************
* MODULE     : keyw_loop.cc
* DESCRIPTION: loops
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <mm_int.hh>

generic
evaluator_rep::evaluate_loop (generic g) {
  list l= as_list (g[1]);
  generic body= g[2];
  bool first= true;
  while (true) {
    list ll= l;
    while (!nil (ll)) {
      generic tag= car (ll);
      if (is_func (tag, MM_WHILE, 1)) {
	generic res= evaluate_as (tag[1], MM_BOOL);
	if (gentype (res) != VALUE_TYPE) return res;
	if (!as_mm_int (as_value (res) -> val) -> i) return VAL_VOID;
      }
      else if (is_func (tag, MM_FOR, 1) && first) {
	generic res= evaluate (tag[1]);
	if (res != VAL_VOID) return res;
      }
      ll= cdr (ll);
    }

    generic res= evaluate (body);
    if (res != VAL_VOID) return res;
    first= false;

    ll= l;
    while (!nil (ll)) {
      generic tag= car (ll);
      if (is_func (tag, MM_UNTIL, 1) && (!first)) {
	generic res= evaluate_as (tag[1], MM_BOOL);
	if (gentype (res) != VALUE_TYPE) return res;
	if (as_mm_int (as_value (res) -> val) -> i) return VAL_VOID;
      }
      else if (is_func (tag, MM_STEP, 1)) {
	generic res= evaluate (tag[1]);
	if (res != VAL_VOID) return res;
      }
      ll= cdr (ll);
    }
  }
  return VAL_VOID;
}
