
/******************************************************************************
* MODULE     : evaluator_test.cc
* DESCRIPTION: Test evaluator
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <iostream.h>

#include <list.hh>
#include <file.hh>
#include <error.hh>
#include <mm_parser.hh>
#include <evaluator.hh>

#define DATA_BEGIN   ((char) 2)
#define DATA_END     ((char) 5)
#define DATA_ESCAPE  ((char) 27)

extern bool texmacs_mode;
static int  counter= 0;

mm_string
input () {
  counter++;
  if (texmacs_mode) {
    cout << DATA_BEGIN << "channel:prompt" << DATA_END;
    cout << DATA_BEGIN << "latex:" << "{\\red Mmx $\\gg$}" << DATA_END;
    cout << DATA_END;
  }
  else cout << counter << "> ";
  fflush (stdout);
  char in[1000];
  cin.getline (in, 1000);
  if (texmacs_mode) cout << DATA_BEGIN << "verbatim:";
  return in;
}

int
main (int argc, char** argv) {
  if (argc == 2) {
    mm_string option (argv[1]);
    texmacs_mode= (option == "--texmacs");
  }

  mm_string s;
  if (texmacs_mode) cout << DATA_BEGIN << "verbatim:";
  cout << "------------------------------------------------------\n";
  cout << "Welcome to mathemagix\n";
  cout << "This software comes with no warranty whatsoever\n";
  cout << "(c) 2001  by Joris van der Hoeven\n";
  cout << "------------------------------------------------------\n";
  while (true) {
    s= input ();
    if ((s == "quit") || (s == "quit;")) break;
    if ((s == "exit") || (s == "exit;")) break;
    if ((s == "bye") || (s == "bye;")) break;
    if ((s == "") || (s == ";")) continue;
    s= "interactive " * s;
    insert_source (s, "cmdline");
    list errors;
    generic g= mm_parse (s, errors);
    if (N(errors)!=0) {
      print_errors (errors);
      continue;
    }
    if (texmacs_mode) cout << DATA_BEGIN << "latex:${\\displaystyle ";
    g= mmx_evaluate (g);
    cout << blank;
    if (texmacs_mode && (gentype (g) == VALUE_TYPE)) {
      value val= as_value (g);
      pp_E0 (val->val);
      cout << " {\\rightflush} {\\blue ";
      pp_E0 (val->type);
      cout << "}";
    }
    else pp_E0 (g);
    cout << stroke;
    if (texmacs_mode) cout << "}$" << DATA_END;
    cout << lf;
  }
  return 0;
}
