
/******************************************************************************
* MODULE     : keyword.hh
* DESCRIPTION: mathemagix keywords
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __KEYWORD_HH
#define __KEYWORD_HH
#include <symbol.hh>

class evaluator_rep;
class keyword_rep;
class keyword {
protected:
  keyword_rep* rep;

public:
  inline keyword (symbol name, generic (evaluator_rep::*fn) (generic));
  inline keyword (keyword_rep* rep2): rep (rep2) {}
  inline friend keyword as_keyword (generic g) {
    if (nil (g) || (gentype (g) != KEYWORD_TYPE)) type_mismatch (g, "keyword");
    return keyword ((keyword_rep*) g.rep); }
  inline operator generic ();
  inline keyword_rep* operator -> () { return rep; }

  friend class keyword_rep;
};

class keyword_rep: generic_rep {
public:
  symbol  name;
  generic (evaluator_rep::*fn) (generic);

public:
  inline keyword_rep (symbol name2, generic (evaluator_rep::*fn2) (generic)):
    name (name2), fn (fn2) {}

  int  Type ();
  void Print (ostream& out);

  friend class keyword;
};

inline keyword::keyword (symbol name, generic (evaluator_rep::*fn) (generic)):
  rep (new keyword_rep (name, fn)) {}
inline keyword::operator generic () { return generic (rep); }

#endif // __KEYWORD_HH
