
/******************************************************************************
* MODULE     : mm_exception.hh
* DESCRIPTION: mathemagix exceptions
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MM_EXCEPTION_HH
#define __MM_EXCEPTION_HH
#include <symbol.hh>

class mm_exception_rep;
class mm_exception {
protected:
  mm_exception_rep* rep;

public:
  inline mm_exception (generic where, char* val);
  inline mm_exception (generic where, generic val, generic type);
  inline mm_exception (mm_exception_rep* rep2): rep (rep2) {}
  inline friend mm_exception as_mm_exception (generic g) {
    if (nil (g) || (gentype (g) != MM_EXCEPTION_TYPE))
      type_mismatch (g, "mm_exception");
    return mm_exception ((mm_exception_rep*) g.rep); }
  inline operator generic ();
  inline mm_exception_rep* operator -> () { return rep; }

  friend class mm_exception_rep;
};

class mm_exception_rep: public generic_rep {
public:
  generic where;
  generic val;
  generic type;

public:
  inline mm_exception_rep (generic where2, generic val2, generic type2):
    where (where2), val (val2), type (type2) {}

  int  Type ();
  void Print (ostream& out);

  friend class mm_exception;
};

inline mm_exception::mm_exception (generic where, char* val):
  rep (new mm_exception_rep (where, symbol (val), symbol ("Exception"))) {}
inline mm_exception::mm_exception (generic where, generic val, generic type):
  rep (new mm_exception_rep (where, val, type)) {}
inline mm_exception::operator generic () { return generic (rep); }

#endif // __MM_EXCEPTION_HH
