
/******************************************************************************
* MODULE     : value.hh
* DESCRIPTION: mathemagix values
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __VALUE_HH
#define __VALUE_HH
#include <generic.hh>

class value_rep;
class value {
protected:
  value_rep* rep;

public:
  inline value (generic val, generic type);
  inline value (value_rep* rep2): rep (rep2) {}
  inline friend value as_value (generic g) {
    if (nil (g) || (gentype (g) != VALUE_TYPE)) type_mismatch (g, "value");
    return value ((value_rep*) g.rep); }
  inline operator generic ();
  inline value_rep* operator -> () { return rep; }

  inline bool operator == (value val);
  inline bool operator != (value val);
  friend value copy (value a);
  friend ostream& operator << (ostream& out, value i);

  friend class value_rep;
};

class value_rep: public generic_rep {
public:
  generic val;
  generic type;

public:
  inline value_rep (generic val2, generic type2):
    val (val2), type (type2) {}

  int  Type ();
  bool Equal (generic g);
  generic Copy ();
  void Print (ostream& out);

  friend class value;
};

inline value::value (generic val, generic type):
  rep (new value_rep (val, type)) {}
inline value::operator generic () { return generic (rep); }
inline bool value::operator == (value val) {
  return (rep->val == val->val) && (rep->type == val->type); }
inline bool value::operator != (value val) {
  return (rep->val != val->val) || (rep->type != val->type); }

extern value VAL_VOID;
value overload (value v1, value v2);

#endif // __VALUE_HH
