
/******************************************************************************
* MODULE     : extern.cc
* DESCRIPTION: for creating Mathemagix extensions
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <extern.hh>
#include <function.hh>

static int  extern_type_id= 256;
static list extern_types;
static list extern_bindings;

int
declare_type (symbol type_name) {
  extern_types= cons (type_name, extern_types);
  return extern_type_id++;
}

void
declare (symbol var_name, generic val, generic type) {
  list binding (var_name, val, type);
  extern_bindings= cons (binding, extern_bindings);
}

void
declare (symbol var_name, mmx_function fn, generic type) {
  function f (var_name, fn);
  list binding (var_name, f, type);
  extern_bindings= cons (binding, extern_bindings);
}

list
get_extern_types () {
  return reverse (extern_types);
}

list
get_extern_bindings () {
  return reverse (extern_bindings);
}

generic
function_type (generic r) {
  generic dom = list (MM_CROSS);
  return list (MM_FUNCTION, dom, r);
}

generic
function_type (generic x1, generic r) {
  generic dom = list (MM_CROSS, x1);
  return list (MM_FUNCTION, dom, r);
}

generic
function_type (generic x1, generic x2, generic r) {
  generic dom = list (MM_CROSS, x1, x2);
  return list (MM_FUNCTION, dom, r);
}

generic
function_type (generic x1, generic x2, generic x3, generic r) {
  generic dom = list (MM_CROSS, x1, x2, x3);
  return list (MM_FUNCTION, dom, r);
}
