
/******************************************************************************
* MODULE     : std_error.cc
* DESCRIPTION: Standard error messages
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <error.hh>

class std_error_rep: public generic_rep {
  mm_string  message;
  generic src;

public:
  inline std_error_rep (mm_string message2, generic src2) :
    generic_rep (src2), message (message2), src (src2) {}
  int Type () { return ERROR_TYPE; }
  void Print (ostream& out);
};

void
std_error_rep::Print (ostream& out) {
  print_error_location (out, src);
  out << symbol (message) << lf;
  print_error_source (out, src);
}

generic
std_error (mm_string message, generic src) {
  return new std_error_rep (message, src);
}
