
/******************************************************************************
* MODULE     : converter_test.cc
* DESCRIPTION: Test converter
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <iostream.h>

#include <list.hh>
#include <file.hh>
#include <error.hh>
#include <mm_parser.hh>
#include <converter.hh>

converter cv;

mm_string
input () {
  char in[1000];
  cout << "> ";
  cin.getline (in, 1000);
  return in;
}

int
main (int argc, char** argv) {
  mm_string s;
  cout << hrule;
  cout << "Welcome to the mathemagix type converter\n";
  cout << "This software comes with no warranty whatsoever\n";
  cout << "(c) 2001  by Joris van der Hoeven\n";
  cout << hrule;
  cout << "Usage:\n";
  cout << "  T => U;\t  attempt to convert from T to U\n";
  cout << "  apply (F, T);\t  attempt to apply function type F to type T\n";
  cout << "  back (F, T);\t  attempt to pullback type T via function type F\n";
  cout << "  cv (T -> U);\t  add a converter from T to U\n";
  cout << "  lcv (T -> U);\t  add a left associative converter from T to U\n";
  cout << "  rcv (T -> U);\t  add a right associative converter from T to U\n";
  cout << hrule;
  while (true) {
    s= input ();
    if ((s == "quit") || (s == "quit;")) break;
    if ((s == "exit") || (s == "exit;")) break;
    if ((s == "bye") || (s == "bye;")) break;
    if ((s == "") || (s == ";")) continue;
    s= "interactive " * s;
    insert_source (s, "cmdline");
    list errors;
    generic g= mm_parse (s, errors);
    if (N(errors)!=0) {
      print_errors (errors);
      continue;
    }
    cv->test (g);
  }
  return 0;
}
