
/******************************************************************************
* MODULE     : match.hh
* DESCRIPTION: matching of expressions
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MATCH_HH
#define __MATCH_HH
#include <quantor.hh>
#include <mm_symbs.hh>

inline generic implies (generic from, generic to) {
  return list (MM_IMPLIES, from, to); }
inline generic arrow (generic from, generic to) {
  return list (MM_FUNCTION, from, to); }

inline bool is_not (generic g) { return is_func (g, MM_NOT, 1); }
inline bool is_and (generic g) { return is_func (g, MM_AND); }
inline bool is_or (generic g) { return is_func (g, MM_OR); }
inline bool is_implies (generic g) { return is_func (g, MM_IMPLIES, 2); }
inline bool is_forall (generic g) { return is_func (g, MM_FORALL, 2); }
inline bool is_exists (generic g) { return is_func (g, MM_EXISTS, 2); }

inline bool is_arrow (generic g) { return is_func (g, MM_FUNCTION, 2); }
inline bool is_cross (generic g) { return is_func (g, MM_CROSS); }
inline bool is_singlet (generic g) { return is_func (g, MM_CROSS, 1); }
inline bool is_alias (generic g) { return is_func (g, MM_ALIAS, 1); }

bool match (generic f, generic g, table& t);
bool merge_matches (table& t, table with);

#endif // __MATCH_HH
