
/******************************************************************************
* MODULE     : parser_test.cc
* DESCRIPTION: Test parser
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <file.hh>
#include <mm_parser.hh>
#include <error.hh>

mm_string
input () {
  char in[1000];
  cout << "in ] ";
  cin.getline (in, 1000);
  return in;
}

void
parse_string (mm_string s) {
  list errors;
  generic output= mm_parse (s, errors);
  print_errors (errors);
  cout << "out] " << output << "\n";
}

int
main (int argc, char** argv) {
  int i;
  mm_string s;

  for (i=1; i<argc; i++) {
    mm_string arg (argv[i]);
    insert_source (arg, "cmdline");
    cout << "Parsing " << arg << "\n";
    cout << hrule;
    if (load (arg, s)) cout << "Couldn't open file\n";
    else parse_string (s);
    cout << hrule;
  }

  if (argc == 1)
    while (true) {
      s= input ();
      if ((s == "quit") || (s == "quit;")) break;
      if ((s == "exit") || (s == "exit;")) break;
      if ((s == "bye") || (s == "bye;")) break;
      if ((s == "") || (s == ";")) continue;
      insert_source (s, "cmdline");
      parse_string (s);
    }

  return 0;
}
