
/******************************************************************************
* MODULE     : lexer.hh
* DESCRIPTION: Lexical analysis of mathemagix files
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __LEXER_HH
#define __LEXER_HH
#include <mm_string.hh>
#include <symbol.hh>

#define YYSTYPE generic
#define yylval mm_lval
extern  YYSTYPE yylval;

extern int   mm_lex_origin;
extern char* mm_lex_string;
extern int   mm_lex_length;
extern int   mm_lex_start;
extern int   mm_lex_prev;
extern int   mm_lex_pos;
extern int   mm_lex ();

inline void
start_lexer (mm_string s) {
  mm_lex_origin= s->begin;
  mm_lex_string= S(s);
  mm_lex_length= N(s);
  mm_lex_start = 0;
  mm_lex_prev  = 0;
  mm_lex_pos   = 0;
}

#endif // __LEXER_HH
