
/******************************************************************************
* MODULE     : mm_symbs.cc
* DESCRIPTION: frequently used symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <mm_symbs.hh>

/******************************************************************************
* Primitives
******************************************************************************/

symbol MM_ACCESS (".[]");
symbol MM_AND ("&&");
symbol MM_ASSIGN (":=");
symbol MM_BEGIN ("begin!");
symbol MM_CASE ("case!");
symbol MM_COMPOSE ("@");
symbol MM_DECLARE ("declare!");
symbol MM_DEFINE ("==");
symbol MM_DOLLAR ("$");
symbol MM_DOT (".");
symbol MM_DOTS ("..");
symbol MM_ELSE ("else!");
symbol MM_EQUAL ("=");
symbol MM_EQUIV ("<=>");
symbol MM_ERROR ("error!");
symbol MM_EXISTS ("exists!");
symbol MM_EXPORT ("export!");
symbol MM_FACTORIAL (".!");
symbol MM_FOR ("for!");
symbol MM_FORALL ("forall!");
symbol MM_GTR (">");
symbol MM_GTREQ (">=");
symbol MM_GTRGTR (">>");
symbol MM_HAS ("has!");
symbol MM_HOLDS ("holds!");
symbol MM_IF ("if!");
symbol MM_IMPLIES ("=>");
symbol MM_IMPORT ("import!");
symbol MM_LAMBDA ("lambda!");
symbol MM_LESS ("<");
symbol MM_LESSEQ ("<=");
symbol MM_LESSLESS ("<<");
symbol MM_LOCAL ("local!");
symbol MM_LOOP ("loop!");
symbol MM_MIGRATE ("migrate!");
symbol MM_MODIFY ("mod!");
symbol MM_MINUS ("-");
symbol MM_MINUSASSIGN ("-=");
symbol MM_NOT ("!");
symbol MM_NOTGTR ("!>");
symbol MM_NOTGTREQ ("!>=");
symbol MM_NOTLESS ("!<");
symbol MM_NOTLESSEQ ("!<=");
symbol MM_NUMBER ("#");
symbol MM_OMINUS ("@-");
symbol MM_OOVER ("@/");
symbol MM_OPLUS ("@+");
symbol MM_OR ("||");
symbol MM_OTIMES ("@*");
symbol MM_OVER ("/");
symbol MM_OVERASSIGN ("/=");
symbol MM_PLUS ("+");
symbol MM_PLUSASSIGN ("+=");
symbol MM_POSTDEC (".--");
symbol MM_POSTINC (".++");
symbol MM_POWER ("^");
symbol MM_PREDEC ("--");
symbol MM_PREINC ("++");
symbol MM_PRIME ("'");
symbol MM_SEQAND ("and!");
symbol MM_SEQOR ("or!");
symbol MM_SQTUPLE ("[]");
symbol MM_STEP ("step!");
symbol MM_TIMES ("*");
symbol MM_TIMESASSIGN ("*=");
symbol MM_TRANSTYPE (":>");
symbol MM_TUPLE ("tuple!");
symbol MM_TYPE (":");
symbol MM_UNEQUAL ("!=");
symbol MM_UNTIL ("until!");
symbol MM_WHILE ("while!");
symbol MM_XOR ("^^");

/******************************************************************************
* Extra symbols for conversions
******************************************************************************/

symbol CONV_FUNCTION ("0#");
symbol CONV_ARGUMENT ("1#");

symbol CONV_APPLY ("apply#");
symbol CONV_CROSS ("cross#");
symbol CONV_LAMBDA ("lambda#");
symbol CONV_UNALIAS ("unalias#");
symbol CONV_UNAND ("unand#");
symbol CONV_UNCROSS ("uncross#");

/******************************************************************************
* Standard types
******************************************************************************/

symbol MM_GENERIC ("Generic");
symbol MM_VOID ("Void");
symbol MM_BOOL ("Bool");
symbol MM_INT ("Int");
symbol MM_STRING ("String");
symbol MM_OSTREAM ("Ostream");
symbol MM_CROSS ("Cross");
symbol MM_FUNCTION ("->");
symbol MM_ALIAS ("Alias");
symbol MM_INTEGER ("Integer");
symbol MM_POLYNOMIAL ("Polynomial");
