
/******************************************************************************
* MODULE     : mm_symbs.hh
* DESCRIPTION: frequently used symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MM_SYMBS_HH
#define __MM_SYMBS_HH
#include <symbol.hh>

/******************************************************************************
* Primitives
******************************************************************************/

extern symbol MM_ACCESS;
extern symbol MM_AND;
extern symbol MM_ASSIGN;
extern symbol MM_BEGIN;
extern symbol MM_CASE;
extern symbol MM_COMPOSE;
extern symbol MM_DECLARE;
extern symbol MM_DEFINE;
extern symbol MM_DOLLAR;
extern symbol MM_DOT;
extern symbol MM_DOTS;
extern symbol MM_ELSE;
extern symbol MM_EQUAL;
extern symbol MM_EQUIV;
extern symbol MM_ERROR;
extern symbol MM_EXISTS;
extern symbol MM_EXPORT;
extern symbol MM_FACTORIAL;
extern symbol MM_FOR;
extern symbol MM_FORALL;
extern symbol MM_GTR;
extern symbol MM_GTREQ;
extern symbol MM_GTRGTR;
extern symbol MM_HAS;
extern symbol MM_HOLDS;
extern symbol MM_IF;
extern symbol MM_IMPLIES;
extern symbol MM_IMPORT;
extern symbol MM_LAMBDA;
extern symbol MM_LESS;
extern symbol MM_LESSEQ;
extern symbol MM_LESSLESS;
extern symbol MM_LOCAL;
extern symbol MM_LOOP;
extern symbol MM_MIGRATE;
extern symbol MM_MINUS;
extern symbol MM_MINUSASSIGN;
extern symbol MM_MODIFY;
extern symbol MM_NOT;
extern symbol MM_NOTGTR;
extern symbol MM_NOTGTREQ;
extern symbol MM_NOTLESS;
extern symbol MM_NOTLESSEQ;
extern symbol MM_NUMBER;
extern symbol MM_OMINUS;
extern symbol MM_OOVER;
extern symbol MM_OPLUS;
extern symbol MM_OR;
extern symbol MM_OTIMES;
extern symbol MM_OVER;
extern symbol MM_OVERASSIGN;
extern symbol MM_PLUS;
extern symbol MM_PLUSASSIGN;
extern symbol MM_POSTDEC;
extern symbol MM_POSTINC;
extern symbol MM_POWER;
extern symbol MM_PREDEC;
extern symbol MM_PREINC;
extern symbol MM_PRIME;
extern symbol MM_TIMES;
extern symbol MM_TIMESASSIGN;
extern symbol MM_SEQAND;
extern symbol MM_SEQOR;
extern symbol MM_SQTUPLE;
extern symbol MM_STEP;
extern symbol MM_TRANSTYPE;
extern symbol MM_TUPLE;
extern symbol MM_TYPE;
extern symbol MM_UNEQUAL;
extern symbol MM_UNTIL;
extern symbol MM_WHILE;
extern symbol MM_XOR;

/******************************************************************************
* Extra symbols for conversions
******************************************************************************/

extern symbol CONV_FUNCTION;
extern symbol CONV_ARGUMENT;

extern symbol CONV_APPLY;
extern symbol CONV_CROSS;
extern symbol CONV_LAMBDA;
extern symbol CONV_UNALIAS;
extern symbol CONV_UNAND;
extern symbol CONV_UNCROSS;

/******************************************************************************
* Standard types
******************************************************************************/

extern symbol MM_GENERIC;
extern symbol MM_VOID;
extern symbol MM_BOOL;
extern symbol MM_INT;
extern symbol MM_STRING;
extern symbol MM_OSTREAM;
extern symbol MM_CROSS;
extern symbol MM_FUNCTION;
extern symbol MM_ALIAS;
extern symbol MM_INTEGER;
extern symbol MM_POLYNOMIAL;

#endif // __MM_SYMBS_HH
