
/******************************************************************************
* MODULE     : gc_test.cc
* DESCRIPTION: Test garbage collector and mm_strings
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <mm_string.hh>

void
gc_inspect () {
  cout << "-------------------\n";
  cout << "Allocated: " << GC_get_heap_size () << "\n";
  cout << "Collected: " << GC_get_bytes_since_gc() << "\n";
  cout << "-------------------\n";
}

int
main () {
  int i;
  mm_string s;
  gc_inspect ();
  for (i=0; i<10; i++) {
    s= mm_string ("Hallo allemaal");
    cout << i << ": " << s << "\n";
    s= mm_string ("Hop");
    cout << i << ": " << s << "\n";
  }
  gc_inspect ();
  cout << "Collect garbage\n";
  GC_gcollect ();
  gc_inspect ();
  cout << "s = " << s << " on exit\n";
  return 0;
}
