
/******************************************************************************
* MODULE     : table_test.cc
* DESCRIPTION: Test tables and symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <iostream>
#include <mm_string.hh>
#include <symbol.hh>
#include <array.hh>

int
main () {
  table t;
  cout << t << "\n";
  t (mm_string ("Hallo")) = mm_string ("Hop");
  cout << "ok\n";
  cout << t << "\n";
  t (mm_string ("Walhalla")) = mm_string ("Hop");
  cout << t << "\n";
  t (mm_string ("Walhalla")) = mm_string ("Hallo");
  cout << t << "\n";
  t (array (mm_string ("Hallo"), mm_string ("Ploef"))) = mm_string ("Hola");
  t (list (mm_string ("Boem"), mm_string ("Ploef"))) = mm_string ("Hum");
  cout << t << "\n";
  t->reset (mm_string ("Hallo"));
  cout << t << "\n";
  cout << "----------------------------------------------------------------\n";
  symbol x (mm_string ("x"));
  symbol y (mm_string ("y"));
  symbol z (mm_string ("z"));
  symbol x2 (mm_string ("x"));
  cout << x << ", " << y << ", " << z << ", " << x2 << "\n";
  cout << "x = y ? " << (x==y) << "\n";
  cout << "x = x ? " << (x==x2) << "\n";
  return 0;
}
