
/******************************************************************************
* MODULE     : mm_int.cc
* DESCRIPTION: mm_ints
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <mm_int.hh>

/******************************************************************************
* Required mm_ints for generic structures
******************************************************************************/

int
mm_int_rep::Type () {
  return MM_INT_TYPE;
}

int
mm_int_rep::Hash () {
  return i;
}

bool
mm_int_rep::Equal (generic g) {
  if (gentype (g) != MM_INT_TYPE) return false;
  return mm_int (this) == as_mm_int (g);
}

generic
mm_int_rep::Copy () {
  return copy (mm_int (this));
}

int
mm_int_rep::Arity () {
  return 0;
}

void
mm_int_rep::Print (ostream& out) {
  out << mm_int (this);
}

/******************************************************************************
* Routines for mm_ints
******************************************************************************/

ostream&
operator << (ostream& out, mm_int i) {
  return out << i->i;
}

mm_int
copy (mm_int i) {
  return mm_int (i->i);
}
