
/******************************************************************************
* MODULE     : mm_int.hh
* DESCRIPTION: mathemagix output streams
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MM_INT_HH
#define __MM_INT_HH
#include <list.hh>

class mm_int;
class mm_int_rep: generic_rep {
public:
  int i;  // the ostream

protected:
  int Type ();
  int Hash ();
  bool Equal (generic g);
  generic Copy ();
  int Arity ();
  void Print (ostream& out);

public:
  inline mm_int_rep (int i2): i (i2) {}

  friend class mm_int;
  friend mm_int copy (mm_int t);
  friend ostream& operator << (ostream& out, mm_int a);
};

class mm_int {
protected:
  mm_int_rep* rep;
  inline mm_int (mm_int_rep* rep2): rep (rep2) {}

public:
  inline mm_int (int i): rep (new mm_int_rep (i)) {}
  inline friend mm_int as_mm_int (generic g) {
    if (gentype(g) != MM_INT_TYPE) type_mismatch (g, "mm_int");
    return mm_int ((mm_int_rep*) g.rep); }
  inline operator int () { return rep->i; }
  inline operator generic () { return generic (rep); }
  inline mm_int_rep* operator -> () { return rep; }

  inline bool operator == (mm_int out) {
    return (rep->i == out->i); }
  inline bool operator != (mm_int out) {
    return (rep->i != out->i); }
  friend mm_int copy (mm_int i);
  friend ostream& operator << (ostream& out, mm_int i);

  friend class mm_int_rep;
};

#endif // __MM_INT_HH
