
/******************************************************************************
* MODULE     : mm_ostream.cc
* DESCRIPTION: mm_ostreams
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <mm_ostream.hh>

/******************************************************************************
* Required routines for generic structures
******************************************************************************/

int
mm_ostream_rep::Type () {
  return MM_OSTREAM_TYPE;
}

int
mm_ostream_rep::Hash () {
  return hash (name) ^ 12345;
}

bool
mm_ostream_rep::Equal (generic g) {
  if (gentype (g) != MM_OSTREAM_TYPE) return false;
  return mm_ostream (this) == as_mm_ostream (g);
}

generic
mm_ostream_rep::Copy () {
  return copy (mm_ostream (this));
}

int
mm_ostream_rep::Arity () {
  return 0;
}

void
mm_ostream_rep::Print (ostream& out) {
  out << mm_ostream (this);
}

/******************************************************************************
* Routines for mm_ostreams
******************************************************************************/

ostream&
operator << (ostream& out, mm_ostream f) {
  return out << "ostream<" << f->name << ">";
}

mm_ostream
copy (mm_ostream out) {
  return mm_ostream (out->name, out->out);
}
